/***************************************************************************************
*****Fichier contenant les  fonctions d'initialisation                ******************
****************************************************************************************/

/********************Fonction initialisation divers*****************/

int init_all() {  //initialise tout, retourne un message d'erreur fonction du type
/*type de retour:
1: tout est ok
-1: erreur clavier
-2: erreur souris
-3: erreur grafique mode
-4: erreur WSA startup
-5: erreur creation socket
-6: erreur attachement socket a adresse et port
-7: erreur de connection au serveur (connection failed)
-8: erreur de timer
*/


//pour les caracteres spciaux
set_uformat(U_ASCII);

//initialisation clavier, souris, mouse
allegro_init();


if(install_timer()!=0)   return -8;
if(install_keyboard()!=0)return -1;
if(install_mouse()==-1)  return -2;

//initilisation grafmode
set_color_depth(32);
if(set_gfx_mode(NILOREA_GFX_MODE,S_W,S_H,0,0)<0){
set_color_depth(24);
if(set_gfx_mode(NILOREA_GFX_MODE,S_W,S_H,0,0)<0){
set_color_depth(16);
if(set_gfx_mode(NILOREA_GFX_MODE,S_W,S_H,0,0)<0){
set_color_depth(32);
if(set_gfx_mode(GFX_AUTODETECT,S_W,S_H,0,0)<0){
set_color_depth(24);
if(set_gfx_mode(GFX_AUTODETECT,S_W,S_H,0,0)<0){
set_color_depth(16);
if(set_gfx_mode(GFX_AUTODETECT,S_W,S_H,0,0)<0){
return -3;

                                           }  }  }  }  }  }

//creation des tampon et chargement du fond
buf=create_bitmap(S_W,S_H);
clear_to_color(buf,makecol(0,0,0));


//chargement de la fenetre de chat
bmp=load_bitmap("bmp\\fond.bmp",NULL);
for(a=0;a<bmp->w;a++){
for(b=0;b<bmp->h;b++){
if(getpixel(bmp,a,b)==makecol(0,0,0))putpixel(bmp,a,b,makecol(255,0,255));
}}

for(a=0;a<10;a++){
for(b=0;b<12;b++){
ITEM[a][b].identifiant=ITEM[a][b].type=ITEM[a][b].nb=-1;
}}
ITEM[0][0].identifiant=100;
ITEM[0][0].type=3;
ITEM[0][0].nb=1;
ITEM[1][0].identifiant=101;
ITEM[1][0].type=4;
ITEM[1][0].nb=1;

//chargement de l'image de la barre de vie
gfxlife=load_bitmap("bmp\\barre_de_vie.bmp",NULL);
gfxmana=load_bitmap("bmp\\barre_de_mana.bmp",NULL);
//chargement du pointeur
pointeur=load_bitmap("bmp\\curseur.bmp",NULL);
//le scroll button
scroll=load_bitmap("bmp\\scroll.bmp",NULL);
//l'inventaire
inventaire=load_bitmap("bmp\\inventaire.bmp",NULL);
//le load
chargement=load_bitmap("bmp\\chargement.bmp",NULL);
//le menu
menu=load_bitmap("bmp\\menus.bmp",NULL);
//items
item[3]=load_bitmap("item\\pantalon_toile.bmp",NULL);
//items
item[4]=load_bitmap("item\\pantalon_toile.bmp",NULL);
for(a=0;a<=item[3]->w;a++){
for(b=0;b<=item[3]->h;b++){
if(getpixel(item[3],a,b)==makecol(0,255,0))putpixel(item[3],a,b,makecol(255,0,255));
if(getpixel(item[4],a,b)==makecol(0,255,0))putpixel(item[4],a,b,makecol(255,0,255));
}
}


for(a=0;a<pointeur->w;a++)
for(b=0;b<pointeur->h;b++)
if(getpixel(pointeur,a,b)==makecol(0,255,0))putpixel(pointeur,a,b,makecol(255,0,255));


/***********On cree le sol**************/

for(a=0;a<NOMAX;a++)
create_object(&ACTIFS[a]);

for(a=0;a<NANIM;a++){
for(b=0;b<3;b++){
for(c=0;c<8;c++){
for(d=0;d<50;d++){
GFX[a][b][c][d].x=GFX[a][b][c][d].y=GFX[a][b][c][d].exist=GFX[a][b][c][d].duree=0;
                    }}}}


//affichage du menu d'acceuil
if(load_menu()==4){
closesocket(sock);
WSACleanup();
allegro_exit();
exit(-1);
}

rectfill(screen,200,250,600,350,makecol(25,25,25));
textout_centre(screen,font,"Chargement et conection au jeu...",400,295,makecol(255,255,255));

//chargement de la map
load_map();

//chargement des textures
look_at_tiles();

//chargement des objets
look_at_objs();

//chargement des skins
look_at_skins();

if((mousemap=load_bitmap("needed\\colormap.bmp",NULL))==NULL)return -1;

//on cree l'espace WSA et on l'initialise
if((WSAStartup(MAKEWORD(2,0), &WSAData))!=0)return -4;

//creation du socket
if((sock = socket(AF_INET, SOCK_STREAM, 0))==-1)return -5;

//remplissage des struct adresse et port, type
serv_in.sin_addr.s_addr			= inet_addr(DEST_IP);
serv_in.sin_family				= AF_INET;
serv_in.sin_port				= htons(DEST_PORT);

//attachage a la socket
if(bind(sock, (struct sockaddr *)&serv_in, sizeof(serv_in))!=-1)return -6;

//connection au serveur
if(connect(sock, (struct sockaddr *)&serv_in,sizeof(serv_in))<0)return -7;

return 1;  //si tout est OK on retourne la fonction

} //fin initialisation

/* timer interrupt handler */
void time_by_2(void)
{



pthread_mutex_lock(&timelock);
net_loop+=2;
the_time+=2;
pthread_mutex_unlock(&timelock);

}
END_OF_FUNCTION(time_by_2);


