/* 
   Name: Misc.h
   Author: Castagnier Mickal
   Description: Contient les dclaration de variables, fonctions, ect...
   Date:  19/11/03
   Copyright: Nilorea.com

*/

/*******************************************************************************
*****Fichier contenant les declaration generale par type ***********************
*******************************************************************************/

#define ClientVers 62

/*************************************INCLUDES*********************************/

#include <math.h>
#include <allegro.h>  //librairie grafique, clavier , souris
#include <winalleg.h> //complement de librairie a inclure si sous Window$
#include <winsock2.h> //librairie de communication rseau
#include <pthread.h>  //libraire de multi process
#include <stdio.h>

#define  LOOP 20



/*********************************Variables************************************/

int a,
    b,c,d,e,k,
    dx,
    dy,
    thetime=0, //(temps courant)
    error1,  //prend la valeure -1 si une erreur d'emission apparait
    error2,  //prend la valeure -1 si une erreur d'emission apparait
    quit,    //variable signalant le besoin de quitter
    Disp_mode=0, //Type d'affichage sans fond, avec moitie de fond, total
    cur=0,       //position du curseur
    recorded=0,  //nombre de messages en file d'affichage
    Chat_roll_pos=0,   //position du curseur dans la file d'attente des messages
    act_obj_index=0,   //index de la prochaine case libre des objets actifs
    anim_time=0,       //variable de reception du timer
    angledir=0,               //angle que fait la souris avec le joueur sur 360 deg
    screenb=0,            //position du bouton scroll a faire
    synchro=1,            //si la synchro merde est a 0
    tsynchro,             //idem
    cible_index=-1,       //index de la cible vise
    tmpcible_index,       //temporaire de cible index
    MainMode=0,           //mode d'affichage en cour 0 normal 1 inventaire 2 chan
   net_loop=0,           //dure d'une boucle de reseau
    auto_move=0,          //si auto_move =0 mouvement manuel ou arret = 1 diriger le perso vers les coordones =2 diriger et attaquer.
    targobj_id=-1,      //id de la cible
    incomming_use=0,   //a zero si pas de nouvel arrivant, sinon a 1, et a deux si analys.

    //variables de competences et defauts
    fatigue=0,
    faim=0,
    soif=0,
    player_xp=0,
    playermana=100;

//le chemin d'acces de l'animation du joueur
char Anim_path[256];

  float  looptime=0;           //dure d'une boucle a soustraire de la pause


volatile int the_time=0; //variable du timer d'animation
volatile int bnd_time=0; //variable du timer de bande passante


#define BUFSIZE 256
#define MAXSIZE BUFSIZE+64   //Taille maximale (texte + parametres)


//formule de restitution des coordone du joueur

#define P_X player.casex*100+player.x  //en x
#define P_Y player.casey*100+player.y  //en y



/************************************Grafiques*********************************/

#define S_W 800  //resolution x de l'ecran
#define S_H 600  //resolution y de l'ecran

#define NANIM 100 //nombre d'animations gres par le moteur

//#define DEBUG_MODE // si defini affiche des informations de deboguage

//#define NILOREA_GFX_MODE GFX_DIRECTX //en mode plein ecran

#define NILOREA_GFX_MODE GFX_AUTODETECT_WINDOWED //ou fenetr


BITMAP *gfxlife; //image de la barre de vie
BITMAP *gfxmana; //image de la barre de mana
BITMAP *bmp;     //ecran virtuel pour le chat
BITMAP *buf;     //                      ecran
BITMAP *pointeur;     //                 la souris
BITMAP *scroll;       //                 le bouton de scroll
BITMAP *inventaire;   //                 l'inventaire
BITMAP *chargement;   //                 le chargement
BITMAP *menu;         //                 le menu
BITMAP *item[10];     //                 les items



//strucuture sprite
typedef struct Sprite {
int x,y,    //point chaud x,y
    duree,  //duree en miliseconde de l'image (a programmer)
    exist;  //si le sprite est vide, =0 sinon =1
BITMAP *spr;//le sprite de l'animation
}Sprite;

Sprite GFX[NANIM][3][8][50];

/*******************************************Reseau*****************************/

SOCKET sock;             //socket d'emission reception
SOCKADDR_IN serv_in;     //structure de reception de l'ip , ect

WSADATA WSAData;         //variable a initaliser au demarrage du reseau
#define DEST_PORT 54321   //port de conection initial

char DEST_IP[256]="69.93.160.133"; //ip de connection



/************************************THREAD************************************/

static pthread_t Net_Thr; //communication thread

pthread_mutex_t mainlock; //verrou de protextion des shared datas
pthread_mutex_t timelock; //verrou de protextion du timer de bande passante

  /*!
 * Timing Structure ( not yet cross-compilable )
 */


typedef struct N_TIME {

/*! here will be stored the delta time between init and each get */
float timer;

int /*! start time */
    tts,
    /*! end time */
    tte;

LARGE_INTEGER    /*! start time */
                 ts,
                 /*! end time */
                 te;

/*! frequency */
LONGLONG freq ;

/*! frequency */
double freqd;

}N_TIME;

N_TIME loopt;

/*
 * Initialize any N_TIME HiTimer
 */

int init_HiTimer( N_TIME *timer );



/*
 * Poll any N_TIME HiTimer
 */

float get_HiTimer( N_TIME *timer );

/**************************************Chat************************************/

#define Chat_x 40     //position x du curseur
#define Chat_y 575    //position y du curseur
#define NQMAX 250     //capacit en messages du tampon d'affichage
#define NOMAX 250     //capacit en messages du tampon d'affichage

char keybuff[MAXSIZE];       //tampon de saisie du clavier
char linkbuf[MAXSIZE];       //tampon de saisie du clavier -> linker au reseau
char Tampon[NQMAX][MAXSIZE]; //tampon d'affichage
char TEMPINC[4][MAXSIZE];    //tampon d'affichage pour le multilignes
char saved[MAXSIZE];         //derniere phrase tape


/***********************************Includes du jeux***************************/


#include "object.h"  //declaration du type MAP & TILE
#include "2disobegin.h"  //declaration du type MAP & TILE
#include "gfxlib.h"   //declaration du type TILE
#include "User.h"        //declaration du type User, variables & fonctions
#include "Grafics.h"     //declaration des fonctions de traitement grafiques
#include "gameplay.h"    //declaration des fonctions de gameplay
#include "Init.h"        //desciptif de la fonction d'initialisation


